import { defineStore } from 'pinia'
import { ContactsState, UserItemDto } from './types'
import { userStates } from 'AnyR/states/wsStates'
const useContactsStore = defineStore('contacts', {
    state: (): ContactsState => {
        return {
            showWait: false, //是否等待接通
            chooseUser: undefined, //当前选中的联系人
            userList: [] //所有联系人
        }
    },

    getters: {
        //获取合并ws后的所有用户列表
        getAllOnlineContacts(state) {
            const userList = [] as UserItemDto[]
            state.userList.forEach((item1) => {
                userStates.value.onlineContacts.forEach((item2: any) => {
                    if (item1.id == item2.fromID) {
                        Object.assign(item1, item2)
                    }
                })
                userList.push(item1)
            })
            return userList
        },
        //获取ws的用户列表
        getOnlineContacts(state) {
            const userList = [] as UserItemDto[]
            userStates.value.onlineContacts.forEach((item1: any) => {
                state.userList.forEach((item2) => {
                    if (item1.fromID == item2.id) {
                        Object.assign(item1, item2)
                    }
                })
                userList.push(item1)
            })
            return userList
        }
    },

    actions: {
        //设置当前选中联系人
        setChooseUser(info: UserItemDto | undefined) {
            this.chooseUser = info
        },
        //修改通话状态
        changeWait(val: boolean) {
            this.showWait = val
        },
        //获取全部联系人
        setUserList(info: UserItemDto[]) {
            this.userList = info
        }
    },

    persist: {
        storage: sessionStorage // 存储的类型，默认localStorage
    }
})

export default useContactsStore
